## START: Set by rpmautospec
## (rpmautospec version 0.6.3)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 1;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

%bcond_without check

# golang(github.com/bazelbuild/rules_go/go/tools/coverdata) is bundled.
# golang(golang.org/x/sys/cpu) is automatically required only on aarch64
# which is a bad thing for noarch packages;
# filtering it out from automatic requires and requiring it explicitly
# (see below).
%global __requires_exclude %{?__requires_exclude:%{__requires_exclude}|}^golang\\(github.com/bazelbuild/rules_go/go/tools/coverdata\\)$|^golang\\(golang.org/x/sys/cpu\\)$


# https://github.com/google/gvisor
%global goipath         gvisor.dev/gvisor
%global forgeurl        https://github.com/google/gvisor
Version:                20240408.0
# taken from the "go" branch (as bazel is not available in fedora)
%global commit          9e5a99b8205044766a6b5267f6207c00fff83250

%global golang_arches   x86_64 aarch64

%global godevelheader %{expand:
# Workaround for architecture-dependent requires for noarch packages.
# Conditionally compiled file requires this only on aarch64.
# filtering it out from automatic requires and requiring it explicitly.
Requires: golang(golang.org/x/sys/cpu)
}

%gometa

%global common_description %{expand:
gVisor is an open-source, OCI-compatible sandbox runtime that provides
a virtualized container environment. It runs containers with a new
user-space kernel, delivering a low overhead container security
solution for high-density applications.

gVisor integrates with Docker, containerd and Kubernetes, making it
easier to improve the security isolation of your containers while
still using familiar tooling. Additionally, gVisor supports a variety
of underlying mechanisms for intercepting application calls, allowing
it to run in diverse host environments, including cloud-hosted virtual
machines.}

%global gosupfiles      ${vendor[@]}

%global golicenses      LICENSE
%global godocs          README.md AUTHORS

Name:           %{goname}
Release:        %autorelease
Summary:        A container sandbox runtime focused on security, efficiency, and ease of use

# Upstream license specification: Apache-2.0
License:        Apache-2.0
URL:            %{gourl}
Source0:        %{gosource}
Source1:        https://github.com/bazelbuild/rules_go/raw/master/go/tools/coverdata/coverdata.go
Patch0:         golang-gvisor-copyconsole.patch
Patch1:         golang-gvisor-startshim.patch
Patch2:         golang-gvisor-setscore.patch
Patch3:         golang-gvisor-marshalany.patch

%description
%{common_description}

%gopkg

%prep
%goprep -A
mkdir -p vendor/github.com/bazelbuild/rules_go/go/tools/coverdata/
cp %{S:1} vendor/github.com/bazelbuild/rules_go/go/tools/coverdata/
%autopatch -p1

%generate_buildrequires
(%{go_generate_buildrequires}) | grep -F -v 'golang(github.com/bazelbuild/rules_go/go/tools/coverdata)'

%build
%gobuild -o %{gobuilddir}/bin/runsc %{goipath}/runsc

%install
mapfile -t vendor <<< $(find vendor -type f)
%gopkginstall
install -m 0755 -vd                     %{buildroot}%{_bindir}
install -m 0755 -vp %{gobuilddir}/bin/* %{buildroot}%{_bindir}/

%if %{with check}
%check
%gocheck
%endif

%files
%license LICENSE
%doc README.md AUTHORS
%{_bindir}/*

%gopkgfiles

%changelog
## START: Generated by rpmautospec
* Thu Apr 18 2024 Oleg Girko <ol@infoserver.lv> - 20240408.0-1
- Update to 20240408.0

* Sun Feb 11 2024 Maxwell G <maxwell@gtmx.me> - 20211129.0-13
- Rebuild for golang 1.22.0

* Wed Jan 24 2024 Fedora Release Engineering <releng@fedoraproject.org> - 20211129.0-12
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Sat Jan 20 2024 Fedora Release Engineering <releng@fedoraproject.org> - 20211129.0-11
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Thu Jul 20 2023 Fedora Release Engineering <releng@fedoraproject.org> - 20211129.0-10
- Rebuilt for https://fedoraproject.org/wiki/Fedora_39_Mass_Rebuild

* Thu Jan 19 2023 Fedora Release Engineering <releng@fedoraproject.org> - 20211129.0-9
- Rebuilt for https://fedoraproject.org/wiki/Fedora_38_Mass_Rebuild

* Wed Aug 10 2022 Maxwell G <gotmax@e.email> - 20211129.0-8
- Rebuild to fix FTBFS

* Thu Jul 21 2022 Fedora Release Engineering <releng@fedoraproject.org> - 20211129.0-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_37_Mass_Rebuild

* Tue Jul 19 2022 Maxwell G <gotmax@e.email> - 20211129.0-6
- Rebuild for
  CVE-2022-{1705,32148,30631,30633,28131,30635,30632,30630,1962} in golang

* Sat Jun 18 2022 Robert-André Mauchin <zebob.m@gmail.com> - 20211129.0-4
- Rebuilt for CVE-2022-1996, CVE-2022-24675, CVE-2022-28327,
  CVE-2022-27191, CVE-2022-29526, CVE-2022-30629

* Thu Jan 20 2022 Fedora Release Engineering <releng@fedoraproject.org> - 20211129.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Mon Dec 20 2021 Robert-André Mauchin <zebob.m@gmail.com> - 20211129.0-2
- Rebuild for new golist Fix: rhbz#2033983

* Fri Dec 17 2021 Robert-André Mauchin <zebob.m@gmail.com> - 20211129.0-1
- Update to 20211129.0

* Thu Jul 22 2021 Fedora Release Engineering <releng@fedoraproject.org> - 20201216.0-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild

* Thu Jan 28 13:00:45 CET 2021 Robert-André Mauchin <zebob.m@gmail.com> - 20201216.0-3
- Fix the vendoring of github.com/bazelbuild/rules_go
- Close: rhbz#1917351

* Tue Jan 26 2021 Fedora Release Engineering <releng@fedoraproject.org> - 20201216.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_34_Mass_Rebuild

* Wed Jan 13 20:38:43 CET 2021 Robert-André Mauchin <zebob.m@gmail.com> - 20201216.0-1
- Update to 20201216.0

* Wed Aug 05 23:07:20 CEST 2020 Robert-André Mauchin <zebob.m@gmail.com> - 20200804.0-1.20200805git1d6b9c1
- Update to 20200804.0

* Sat Aug 01 2020 Fedora Release Engineering <releng@fedoraproject.org> - 20200211.0-3
- Second attempt - Rebuilt for
  https://fedoraproject.org/wiki/Fedora_33_Mass_Rebuild

* Mon Jul 27 2020 Fedora Release Engineering <releng@fedoraproject.org> - 20200211.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_33_Mass_Rebuild

* Tue Mar 03 2020 Marc-André Lureau <marcandre.lureau@redhat.com> - 20200211.0-1.20200220git384ed13
- Initial package - rhbz#1804288

## END: Generated by rpmautospec
